// WaitDialog.cpp : implementation file
//

#include "stdafx.h"
#include "ComNdrInspector.h"
#include "WaitDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaitDialog dialog


CWaitDialog::CWaitDialog(CWnd* pParent /*=NULL*/, PVOID* ppvMemoryPtr /*= NULL*/)
	: CDialog(CWaitDialog::IDD, pParent),
	m_dwProgBarMax( 0 ), m_pParent( (CComNdrInspectorDlg*) pParent ), m_ppvMemoryPtr( ppvMemoryPtr )
{
	//{{AFX_DATA_INIT(CWaitDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CWaitDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaitDialog)
	DDX_Control(pDX, IDC_PROGRESS, m_wndProgress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWaitDialog, CDialog)
	//{{AFX_MSG_MAP(CWaitDialog)
	//}}AFX_MSG_MAP
	ON_MESSAGE( MACRO_MSG_WAITCOMPLETE, OnWaitComplete )
	ON_MESSAGE( MACRO_MSG_ADDSTRING, OnAddString )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

DWORD WINAPI CWaitDialog::WorkerThread( LPVOID lpParameter )
{
	CWaitDialog*		pThis = (CWaitDialog*) lpParameter;

	* pThis->m_ppvMemoryPtr = NULL;

	//
	// get from the registry.
	//

	BOOL		bError = FALSE;

	DWORD		dwPrevProg = 0;

	LONG		lRet;

	HKEY		hInt = NULL;
	lRet = ::RegOpenKey( HKEY_CLASSES_ROOT, "Interface", & hInt );
	if ( lRet == ERROR_SUCCESS )
	{
		DWORD		dwSubKeys = 0;
		lRet = ::RegQueryInfoKey( hInt, NULL, NULL, NULL, & dwSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
		if ( lRet == ERROR_SUCCESS )
		{
			// alloc mem for guids.

			DWORD			dwGuidMemoryElements = dwSubKeys + 0x80;
			* pThis->m_ppvMemoryPtr = (PVOID) ::malloc( dwGuidMemoryElements * sizeof( GUID ) );
			if ( * pThis->m_ppvMemoryPtr )
			{
				GUID*		pguidPtr = (GUID*) * pThis->m_ppvMemoryPtr;

				// enumerate keys.

				CHAR		szBuffer[ MACRO_LISTBOXITEM_MAXLEN ];

				for ( int i=0; ; i ++ )
				{
					CHAR		szName[ MAX_PATH ];
					DWORD		dwLen = sizeof( szName );
					FILETIME	ftTime;

					lRet = ::RegEnumKeyEx( hInt, i, szName, & dwLen, NULL, NULL, NULL, & ftTime );

					if ( lRet == ERROR_SUCCESS )
					{
						HKEY		hSub = NULL;
						lRet = ::RegOpenKey( hInt, szName, & hSub );
						if ( lRet == ERROR_SUCCESS )
						{
							// query value.

							BOOL		bBufferFilled = FALSE;

							DWORD		dwType = 0;
							DWORD		dwDataLen = sizeof( szBuffer );

							lRet = ::RegQueryValueEx( hSub, NULL, NULL, & dwType, (LPBYTE) szBuffer, & dwDataLen );
							if ( lRet == ERROR_SUCCESS )
							{
								if ( dwDataLen && dwType == REG_SZ )
								{
									bBufferFilled = TRUE;
								}
							}
							else if ( lRet != ERROR_FILE_NOT_FOUND )
							{
								bError = TRUE;
								::AfxMessageBox( "Error when querying interface name in \"Interface\" key in CLASSES_ROOT !" );

								::RegCloseKey( hSub );
								break;
							}

							// add to the lb.

							if ( bBufferFilled == FALSE )
							{
								charstring		csUnnamed = szName;
								::TrimAtBothSides( csUnnamed );

								if ( csUnnamed.size() >= 3 && csUnnamed[ 0 ] != '{' )
									csUnnamed = "{" + csUnnamed + "}";

								::strcpy( szBuffer, "?? " );
								::strcat( szBuffer, csUnnamed.c_str() );
								::strcat( szBuffer, " ??" );
							}

							if ( ::strlen( szBuffer ) == 0 )
								::strcpy( szBuffer, "??" );

							GUID		guid;
							BOOL		bGuidRes = ::CharStrToGuid( szName, & guid );
							if ( bGuidRes )
							{
								// add to the list box.

								if ( i < (int) dwGuidMemoryElements )
								{
									// save GUID.

									* pguidPtr = guid;

									// post mess.

									ADDSTRING_REQUEST*		pRequest = new ADDSTRING_REQUEST( szBuffer, (DWORD) pguidPtr );
									::PostMessage( pThis->GetSafeHwnd(), MACRO_MSG_ADDSTRING, (WPARAM) pRequest, 0 );

									pguidPtr ++;
								}
							}

							// increment progress.

							DWORD		dwProgress = ( pThis->m_dwProgBarMax * i ) / dwSubKeys;

							if ( dwProgress != dwPrevProg )
							{
								// check the event.

								if ( ::WaitForSingleObject( pThis->m_pParent->m_hExitFromThread, 0 ) == WAIT_OBJECT_0 )
								{
									::RegCloseKey( hSub );
									break;
								}

								// update.

								dwPrevProg = dwProgress;
								::PostMessage( pThis->m_wndProgress.GetSafeHwnd (), PBM_SETPOS, dwProgress, 0 );
							}

							// close key.

							::RegCloseKey( hSub );
						}
						else
						{
							bError = TRUE;
							::AfxMessageBox( "Error when opening interface subkey !" );
							break;
						}
					}
					else if ( lRet == ERROR_NO_MORE_ITEMS )
					{
						break;
					}
					else
					{
						bError = TRUE;
						::AfxMessageBox( "Error when enumerating interfaces in \"Interface\" key in CLASSES_ROOT !" );
						break;
					}
				}
			}
			else
			{
				bError = TRUE;
				::AfxMessageBox( "Unable to allocate memory for GUIDs !" );
			}
		}
		else
		{
			bError = TRUE;
			::AfxMessageBox( "Error when calling RegQueryInfoKey on \"Interface\" key in CLASSES_ROOT !" );
		}

		::RegCloseKey( hInt );
	}
	else
	{
		bError = TRUE;
		::AfxMessageBox( "Unable to open \"Interface\" key in CLASSES_ROOT !" );
	}

	//
	// return.
	//

	::SetEvent( pThis->m_pParent->m_hThreadExited );

	if ( bError )
		::PostMessage( pThis->GetSafeHwnd(), WM_CLOSE, 0, 0 );
	else
		::PostMessage( pThis->GetSafeHwnd(), MACRO_MSG_WAITCOMPLETE, 0, 0 );

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CWaitDialog message handlers

BOOL CWaitDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//
	// init everything.
	//

	CRect			clientRect;
	GetClientRect( & clientRect );
	m_dwProgBarMax = clientRect.Width ();

	m_wndProgress.SetRange( 0, (USHORT) m_dwProgBarMax );
	m_wndProgress.SetPos( 0 );

	DWORD			dwThreadId = 0;
	HANDLE			hThread = NULL;
	if ( ( hThread = ::CreateThread( NULL, 0, & WorkerThread, this, 0, & dwThreadId ) ) == NULL )
	{
		::PostQuitMessage( 0 );
		return FALSE;
	}

	::CloseHandle( hThread );

	//
	// return.
	//
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

LRESULT CWaitDialog::OnWaitComplete( WPARAM wp, LPARAM lp )
{
	EndDialog( IDOK );
	return 0;
}

void CWaitDialog::OnCancel() 
{
	::SetEvent( m_pParent->m_hExitFromThread );
	::WaitForSingleObject( m_pParent->m_hThreadExited, INFINITE );
	
	CDialog::OnCancel();
}

LRESULT CWaitDialog::OnAddString( WPARAM wp, LPARAM lp )
{
	ADDSTRING_REQUEST*		pReq = (ADDSTRING_REQUEST*) wp;

	if ( pReq == NULL )
	{
		return 0;
	}
	else if ( pReq->_pszString == NULL )
	{
		delete pReq;
		return 0;
	}

	// add to the lb.

	int			pos = m_pParent->m_wndInterfaces.AddString( pReq->_pszString );
	if ( pos != LB_ERR && pos != LB_ERRSPACE )
		m_pParent->m_wndInterfaces.SetItemData( pos, pReq->_dwData );

	// delete.

	delete pReq;

	// return.

	return 0;
}
